Require Import ZFnats.
Require Export ZF.
Import IZF.

(* duplicate ZFnats *)
(*Definition lt := in_set.
Instance lt_morph : Proper (eq_set ==> eq_set ==> iff) lt.
exact in_set_morph.
Qed.
Definition zero := empty.
*)

(* e' \incl e
ord e e' <->
(forall a, a \in e -> a \in e' -> ord a a) /\
(forall a b, ord b a -> a \incl b -> b \in e -> b \in e' -> a \in e').
*)

Fixpoint plump ub (p:Acc in_set ub) x : Prop :=
  (forall y (q: y \in ub), y \in x -> plump y (Acc_inv p _ q) y) /\
  (forall z y (q: y \in ub), plump y (Acc_inv p _ q) z ->
   z \incl y -> y \in x -> z \in x).

Instance wf_morph : Proper (eq_set ==> iff) (Acc in_set).
do 2 red; intros.
split; intros.
 revert y H.
 induction H0; intros.
 apply Acc_intro; intros.
 rewrite <- H1 in H2.
 apply H0 with y0; trivial.
 reflexivity.

 revert x H.
 induction H0; intros.
 apply Acc_intro; intros.
 rewrite H1 in H2.
 apply H0 with y; trivial.
 reflexivity.
Qed.

Scheme Acc_indd := Induction for Acc Sort Prop.

Lemma plump_morph : forall x x' p p' y y',
  x == x' -> y == y' -> (plump x p y <-> plump x' p' y').
intros x x' p; revert x'.
induction p using Acc_indd; simpl; intros.
destruct p'; simpl.
split; destruct 1; split; intros.
 assert (q' := q).
 rewrite <- H0 in q'.
 rewrite <- H1 in H4.
 rewrite <- (H y0 q' _ _ y0 y0); auto with *.

 assert (q' := q).
 rewrite <- H0 in q'.
 rewrite <- H1 in H6|-*.
 rewrite <- (H y0 q' _ _ z z) in H4; eauto with *.

 assert (q' := q).
 rewrite H0 in q'.
 rewrite H1 in H4.
 rewrite (H _ _ y0 (a0 _ q') _ y0); auto with *.

 assert (q' := q).
 rewrite H0 in q'.
 rewrite H1 in H6|-*.
 rewrite (H _ _ y0 (a0 _ q') _ z) in H4; eauto with *.
Qed.

Lemma plump_bound : forall ub1 ub2 p1 p2 x,
 x \incl ub1 ->
 plump ub1 p1 x -> plump ub2 p2 x.
destruct p1; destruct p2; simpl; intros.
destruct H0.
split; intros.
 assert (y \in ub1).
  apply H; trivial.
 rewrite (plump_morph _ y _ (a _ H3) _ y); auto with *.

 assert (y \in ub1).
  apply H; trivial.
 rewrite (plump_morph _ y _ (a _ H5) _ z) in H2; auto with *.
 apply H1 with y H5; auto.
Qed.

Lemma plump_Acc : forall ub p x,
  plump ub p x -> x \incl ub -> Acc in_set x.
induction p using Acc_indd; simpl; intros.
destruct H0.
constructor; intros.
apply H with y (H1 _ H3); auto with *.
Qed.


Definition isOrd x :=
  { p:Acc in_set x | plump x p x }.

Lemma isOrd_ext : forall x y, x == y -> isOrd x -> isOrd y.
destruct 2.
generalize x0; rewrite H; intro.
exists H0.
rewrite <- (plump_morph x y x0 H0 x y); trivial.
Qed.

Instance isOrd_morph : Proper (eq_set ==> iff) isOrd.
do 2 red; split; intros.
 apply isOrd_ext with x; trivial.

 symmetry in H.
 apply isOrd_ext with y; trivial.
Qed.

Lemma isOrd_inv : forall x y,
  isOrd x -> lt y x -> isOrd y.
intros.
destruct H.
exists (Acc_inv x0 _ H0).
destruct x0; simpl in *.
destruct p; auto.
Qed.


Lemma isOrd_plump : forall z, isOrd z ->
 forall x y, isOrd x -> x \incl y -> y \in z -> x \in z.
destruct 1; intros.
revert p.
destruct x;simpl; intros.
destruct p.
apply H3 with y H1; trivial.
destruct H.
apply plump_bound with (2:=p); reflexivity.
Qed.


Lemma isOrd_intro : forall x,
  (forall a b, isOrd a -> a \incl b -> b \in x -> a \in x) ->
  (forall y, y \in x -> isOrd y) ->
  isOrd x.
intros.
exists (Acc_intro _ (fun y h => proj1_sig (H0 y h))); simpl.
split; intros.
 destruct (H0 y H1).
 rewrite <- (plump_morph y y x0 _ y y); auto with *.

 apply H with y; trivial.
 exists (plump_Acc _ _ _ H1 H2).
 apply plump_bound with (2:=H1); trivial.
Qed.


Lemma isOrd_trans : forall x y z,
  isOrd x -> lt z y -> lt y x -> lt z x.
unfold lt.
destruct 1.
revert y z p.
induction x0 using Acc_indd; simpl; intros.
assert (isOrd x).
 exists (Acc_intro _ a); simpl; trivial.
destruct p.
apply isOrd_plump with y; trivial.
 apply isOrd_inv with y; trivial.
 apply isOrd_inv with x; trivial.

 red; intros.
 apply H with H1 z; auto.
Qed.

Lemma isOrd_ind : forall x (P:set->Prop),
  (forall y y', isOrd y -> y \incl x -> y == y' -> P y -> P y') ->
  (forall y, isOrd y ->
   y \incl x ->
   (forall z, lt z y -> P z) -> P y) ->
  isOrd x -> P x.
intros.
destruct H1.
revert p H H0.
induction x0 using Acc_indd; simpl; intros.
destruct p.
assert (isOrd x).
 exists (Acc_intro _ a); simpl; split; trivial.
apply H1; intros; auto with *.
apply H with H5; intros; auto.
 apply H0 with y; trivial.
 red; intros.
 apply H7 in H10.
 apply isOrd_trans with z; trivial.

 apply H1; trivial.
 red; intros.
 apply H7 in H9.
 apply isOrd_trans with z; trivial.
Qed.

Lemma lt_antirefl : forall x, isOrd x -> ~ lt x x.
induction 1 using isOrd_ind; intros.
 rewrite <- H1; trivial.

 red; intros; apply H1 with y; trivial.
Qed.


Lemma isOrd_zero : isOrd zero.
apply isOrd_intro; intros.
 elim empty_ax with b; trivial.
 elim empty_ax with y; trivial.
Qed.


Definition osucc x := subset (power x) isOrd.

Instance osucc_morph : morph1 osucc.
unfold osucc; do 2 red; intros.
apply subset_morph.
 rewrite H; reflexivity.

 red; auto with *.
Qed.

Lemma lt_osucc : forall x, isOrd x -> lt x (osucc x).
unfold osucc, lt; intros.
apply subset_intro; trivial.
apply power_intro; auto.
Qed.

Hint Resolve isOrd_zero lt_osucc.

Lemma olts_le : forall x y, lt x (osucc y) -> x \incl y.
red; intros.
apply subset_elim1 in H.
apply power_elim with (1:=H); trivial.
Qed.

Lemma ole_lts : forall x y, isOrd x -> x \incl y -> lt x (osucc y).
intros.
apply subset_intro; trivial.
apply power_intro; trivial.
Qed.

Lemma le_lt_trans : forall x y z, isOrd z -> lt x (osucc y) -> lt y z -> lt x z.
intros.
apply isOrd_plump with y; trivial.
 apply subset_elim2 in H0; destruct H0.
 rewrite H0; trivial.

 apply olts_le; trivial.
Qed.

Lemma isOrd_succ : forall n, isOrd n -> isOrd (osucc n).
unfold osucc.
intros.
apply isOrd_intro; intros.
 apply subset_intro; trivial.
 apply subset_elim1 in H2.
 apply power_intro; intros.
 apply H1 in H3.
 apply power_elim with (1:=H2); trivial.

 apply subset_elim2 in H0.
 destruct H0.
 rewrite H0; trivial.
Qed.
Hint Resolve isOrd_succ.

Lemma lt_osucc_compat : forall n m, isOrd m -> lt n m -> lt (osucc n) (osucc m).
intros.
apply ole_lts; auto.
 apply isOrd_succ.
 apply isOrd_inv with m; trivial.

 red; intros.
 apply le_lt_trans with n; trivial.
Qed.

Lemma isOrd_eq : forall o, isOrd o -> o == sup o osucc.
intros.
apply eq_intro; intros.
 rewrite sup_ax.
 2:do 2 red; intros; apply osucc_morph; trivial.
 exists z; auto.
 apply lt_osucc.
 apply isOrd_inv with o; trivial.

 rewrite sup_ax in H0.
 2:do 2 red; intros; apply osucc_morph; trivial.
 destruct H0.
 apply le_lt_trans with x; trivial.
Qed.

(* Increasing *)

Definition increasing F :=
  forall x y, isOrd x -> isOrd y -> y \incl x -> F y \incl F x.
(*
Definition directed o F :=
  forall o', isOrd o -> lt o' o -> F o' \incl F o.
*)
Definition increasing_bounded o F :=
  forall x x', lt x' o -> lt x x' -> F x \incl F x'.

Definition succOrd o := exists2 o', isOrd o' & o == osucc o'.

(* Limit ordinals *)

Definition limitOrd o := isOrd o /\ (forall x, lt x o -> lt (osucc x) o).

Lemma limit_is_ord : forall o, limitOrd o -> isOrd o.
destruct 1; trivial.
Qed.
Hint Resolve limit_is_ord.

Lemma limit_union : forall o, limitOrd o -> union o == o.
destruct 1.
apply eq_intro; intros.
 apply union_elim in H1; destruct H1.
 apply isOrd_trans with x; trivial.

 apply union_intro with (osucc z).
  apply lt_osucc.
  apply isOrd_inv with o; trivial.

  apply H0; trivial.
Qed.

Lemma limit_union_intro : forall o, isOrd o -> union o == o -> limitOrd o.
split; trivial.
unfold lt; intros.
assert (isOrd x).
 apply isOrd_inv with o; trivial.
rewrite <- H0 in H1.
apply union_elim in H1; destruct H1.
apply isOrd_plump with x0; auto.
red; intros.
apply le_lt_trans with x; trivial.
apply isOrd_inv with o; trivial.
Qed.

Lemma discr_lim_succ : forall o, limitOrd o -> succOrd o -> False.
destruct 1; destruct 1.
assert (lt (osucc x) o).
 apply H0.
 rewrite H2; auto.
rewrite <- H2 in H3.
elim lt_antirefl with o; trivial.
Qed.


Section OrdinalUpperBound.

  Variable I : set.
  Variable f : set -> set.
  Hypothesis f_ext : ext_fun I f.
  Hypothesis f_ord : forall x, x \in I -> isOrd (f x).

  Lemma isOrd_supf_intro : forall n, n \in I -> f n \incl sup I f.
red; intros.
rewrite sup_ax; trivial.
exists n; trivial.
Qed.

  Lemma isOrd_supf_elim : forall x, lt x (sup I f) -> exists2 n, n \in I & lt x (f n).
intros.
rewrite sup_ax in H; trivial.
Qed.

  Lemma isOrd_supf : isOrd (sup I f).
apply isOrd_intro; intros.
 elim isOrd_supf_elim with (1:=H1); intros.
 apply isOrd_supf_intro with x; trivial.
 apply isOrd_plump with b; auto.

 elim isOrd_supf_elim with (1:=H); intros.
 apply isOrd_inv with (f x); auto.
Qed.

End OrdinalUpperBound.

(* Projection toward ordinals *)

Definition toOrd (x : set) :=
  sup (subset x isOrd) osucc.

Instance toOrd_morph : morph1 toOrd.
do 2 red; intros.
unfold toOrd.
apply sup_morph.
 apply subset_morph; auto with *.

 red; intros; rewrite H1; reflexivity.
Qed.

Lemma toOrd_isOrd : forall x, isOrd (toOrd x).
intros.
unfold toOrd.
apply isOrd_supf; intros.
 red; red; intros.
 rewrite H0; reflexivity.

 apply isOrd_succ.
 destruct subset_elim2 with (1:=H).
 rewrite H0; trivial.
Qed.

Lemma toOrd_ord : forall o, isOrd o -> toOrd o == o.
intros.
unfold toOrd.
apply eq_intro; intros.
 rewrite sup_ax in H0.
 2:red; red; intros; rewrite H2; reflexivity.
 destruct H0.
 apply le_lt_trans with x; auto.
 apply subset_elim1 with (1:=H0).

 rewrite sup_ax.
 2:red; red; intros; rewrite H2; reflexivity.
 exists z.
  apply subset_intro; trivial.
  apply isOrd_inv with o; trivial.

  apply lt_osucc.
  apply isOrd_inv with o; trivial.
Qed.


Section TransfiniteRecursion.

  Variable F : (set -> set) -> set -> set.
  Hypothesis Fmorph : forall o o' f f',
    o == o' -> eq_fun o f f' -> F f o == F f' o'.

  Definition TR_rel o y :=
    forall P,
    Proper (eq_set ==> eq_set ==> iff) P ->
    (forall o' f, ext_fun o' f ->
     (forall n, lt n o' -> P n (f n)) ->
     P o' (F f o')) ->
    P o y.

  Instance TR_rel_morph : Proper (eq_set ==> eq_set ==> iff) TR_rel.
do 3 red; unfold TR_rel; split; intros.
 rewrite <- H; rewrite <- H0; apply H1; auto.

 rewrite H; rewrite H0; apply H1; auto.
Qed.

  Lemma TR_rel_intro : forall x f,
    ext_fun x f ->
    (forall y, y \in x -> TR_rel y (f y)) ->
    TR_rel x (F f x).
red; intros.
apply H2; trivial; intros.
apply H0; trivial.
Qed.

  Lemma TR_rel_inv : forall x y,
    TR_rel x y ->
    exists2 f,
      ext_fun x f /\ (forall y, y \in x -> TR_rel y (f y)) &
      y == F f x.
intros.
apply (@proj2 (TR_rel x y)).
apply H; intros.
 do 3 red; intros.
 rewrite <- H0; rewrite <- H1.
 split; destruct 1 as (Htr,(f,(fm,eqf),eqF)); split; trivial; exists f; trivial.
  split; intros.
   do 2 red; intros.
   rewrite <- H0 in H2; auto.
   rewrite <- H0 in H2; auto.
  rewrite <- H1; rewrite eqF; apply Fmorph; intros; auto.
  split; intros.
   do 2 red; intros.
   rewrite H0 in H2; auto.
   rewrite H0 in H2; auto.
  symmetry in H0; rewrite H1; rewrite eqF; apply Fmorph; intros; auto.
assert (TR_relsub := fun n h => proj1 (H1 n h)); clear H1.
split.
 apply TR_rel_intro; trivial.

 exists f; auto with *.
Qed.


  Lemma TR_rel_fun :
    forall x y, TR_rel x y -> forall y', TR_rel x y' -> y == y'.
intros x y H.
apply H; intros.
 do 3 red; intros.
 split; intros.
  rewrite <- H1; rewrite <- H0 in H3; auto.
  rewrite H1; rewrite H0 in H3; auto.
apply TR_rel_inv in H2; destruct H2.
destruct H2.
rewrite H3; clear y' H3.
apply Fmorph; intros.
 reflexivity.
red; intros.
apply H1; trivial.
rewrite H5 in H3|-*; auto.
Qed.

Require Import ZFrepl.

  Lemma TR_rel_repl_rel :
    forall x, repl_rel x TR_rel.
split; intros.
 rewrite <- H0; rewrite <- H1; trivial.

 apply TR_rel_fun with x0; trivial.
Qed.

  Lemma TR_rel_def : forall o, isOrd o -> exists y, TR_rel o y.
induction 1 using isOrd_ind; intros.
 destruct IHisOrd.
 rewrite H1 in H2; exists x; trivial.

 assert (forall z, lt z y -> uchoice_pred (fun y => TR_rel z y)).
  intros.
  specialize H1 with (1:=H2).
  destruct H1.
  split; intros.
   rewrite <- H3; trivial.
  split; intros.
   exists x; trivial.
  apply TR_rel_fun with z; trivial.
 exists (F (fun z => uchoice (fun y => TR_rel z y)) y).
 apply TR_rel_intro; intros.
  do 2 red; intros.
  apply uchoice_morph; intros; auto.
  rewrite H4; reflexivity.
 apply uchoice_def; auto.
Qed.

  Lemma TR_rel_choice_pred : forall o, isOrd o ->
    uchoice_pred (fun y => TR_rel o y).
split; intros.
 rewrite <- H0; trivial.
split; intros.
 apply TR_rel_def; trivial.
apply TR_rel_fun with o; trivial.
Qed.

  Definition TR o := uchoice (fun y => TR_rel o y).

  Instance TR_morph : morph1 TR.
do 2 red; intros.
unfold TR.
apply uchoice_morph_raw.
red; intros.
apply TR_rel_morph; trivial.
Qed.
 
  Lemma TR_eqn : forall o, isOrd o -> TR o == F TR o.
unfold TR; intros.
specialize TR_rel_choice_pred with (1:=H); intro.
apply uchoice_def in H0.
apply TR_rel_inv in H0.
destruct H0.
destruct H0.
rewrite H1.
apply Fmorph; intros; auto with *.
red; intros.
apply TR_rel_fun with x'.
 rewrite <- H4; auto.

 apply uchoice_def.
 apply TR_rel_choice_pred.
 rewrite <- H4; apply isOrd_inv with o; trivial.
Qed.

  Lemma TR_ind : forall o (P:set->set->Prop),
    (forall x x', isOrd x -> x \incl o -> x == x' ->
     forall y y', y == y' -> P x y -> P x' y') ->
    isOrd o ->
    (forall y, isOrd y -> y \incl o ->
     (forall x, lt x y -> P x (TR x)) ->
     P y (F TR y)) ->
    P o (TR o).
induction 2 using isOrd_ind; intros.
 apply H with y (TR y); auto.
  apply TR_morph; trivial.

  apply IHisOrd; intros.
  rewrite H2 in H5; auto.
apply H with y (F TR y); auto with *.
 symmetry; apply TR_eqn; trivial.
apply H3; trivial; intros.
 reflexivity.
apply H2; trivial; intros.
apply H3; trivial.
red; intros.
apply H6 in H8.
apply isOrd_trans with x; trivial.
Qed.


  Lemma TR_typ : forall n X,
    morph1 X ->
    isOrd n ->
    (forall y f, isOrd y -> y \incl n ->
     (forall z, lt z y -> f z \in X z) -> F f y \in X y) ->
    TR n \in X n.
intros n X Xm is_ord.
apply TR_ind with (o:=n); intros; trivial.
 rewrite <- H2; rewrite <- H1; apply H3; intros.
 rewrite H1 in H6; auto.
apply H2; intros; auto with *.
apply H1; trivial; intros.
apply H2; auto.
red; intros.
apply H5 in H7.
apply isOrd_trans with z; trivial.
Qed.

End TransfiniteRecursion.


(* Specialized version where the case of limit ordinals is union *)
Section TransfiniteIteration.

  Variable F : set -> set.
  Hypothesis Fmorph : Proper (eq_set ==> eq_set) F.

Let G f o := sup o (fun o' => F (f o')).

Lemma Gmorph : forall o o' f f',
    o == o' -> eq_fun o f f' -> G f o == G f' o'.
unfold G; intros.
apply sup_morph; trivial.
red; auto.
Qed.
Hint Resolve Gmorph.

  Definition TI := TR G.

  Instance TI_morph : morph1 TI.
unfold TI; do 2 red; intros.
apply TR_morph; auto with *.
Qed.

  Lemma TI_fun_ext : forall x, ext_fun x (fun y => F (TI y)).
do 2 red; intros.
apply Fmorph.
apply TI_morph; trivial.
Qed.
Hint Resolve TI_fun_ext.

  Lemma TI_eq : forall o,
    isOrd o ->
    TI o == sup o (fun o' => F (TI o')).
intros.
unfold TI.
apply TR_eqn; auto.
Qed.

  Lemma TI_intro : forall o o' x,
    isOrd o ->
    lt o' o ->
    x \in F (TI o') ->
    x \in TI o.
intros.
rewrite TI_eq; trivial.
rewrite sup_ax; auto.
exists o'; trivial.
Qed.

  Lemma TI_elim : forall o x,
    isOrd o ->
    x \in TI o ->
    exists2 o', lt o' o & x \in F (TI o').
intros.
rewrite TI_eq in H0; trivial.
rewrite sup_ax in H0; auto.
Qed.

  Lemma TI_initial : TI zero == empty.
apply empty_ext; red; intros.
apply TI_elim in H.
 destruct H.
 elim empty_ax with (1:=H).

 apply isOrd_zero.
Qed.

  Lemma TI_typ : forall n X,
    (forall a, a \in X -> F a \in X) ->
    isOrd n ->
    (forall m G, isOrd m -> m \incl n ->
     ext_fun m G ->
     (forall x, lt x m -> G x \in X) -> sup m G \in X) ->
    TI n \in X.
induction 2 using isOrd_ind; intros.
 rewrite <- H2.
 apply IHisOrd; intros.
 apply H3; auto; intros.
 rewrite <- H2; trivial.

 rewrite TI_eq; trivial.
 apply H3 with (G:=fun o => F (TI o)); intros; auto with *.
 apply H.
 apply H2; trivial; intros.
 apply H3; auto.
 red; intros.
 apply H6 in H9.
 apply isOrd_trans with x; trivial.
Qed.

End TransfiniteIteration.
Hint Resolve TI_fun_ext.


(********************************************************************)

Require Import ZFrepl.

Section LimOrd.

  Variable f : nat -> set.
  Variable ford : forall n, isOrd (f n).

  Definition ord_sup :=
    union (repl N (fun x y => exists2 n, x == nat2set n & f n == y)).

  Lemma repl_sup : 
    repl_rel N (fun x y => exists2 n, x == nat2set n & f n == y).
split; intros.
 destruct H2.
 exists x0.
  rewrite <- H0; trivial.
  rewrite <- H1; trivial.

 destruct H0.
 destruct H1.
 rewrite <- H2; rewrite <- H3.
 replace x1 with x0; try reflexivity.
 apply nat2set_inj.
 rewrite <- H0; trivial.
Qed.

  Lemma isOrd_sup_intro : forall n, f n \incl ord_sup.
unfold ord_sup.
red; intros.
apply union_intro with (f n); trivial.
apply repl_intro with (nat2set n).
 exact repl_sup.

 apply nat2set_typ.

 exists n; reflexivity.
Qed.

  Lemma isOrd_sup_elim : forall x, lt x ord_sup -> exists n, lt x (f n).
unfold ord_sup; intros.
elim union_elim with (1:=H); clear H; intros.
elim repl_elim with (1:=repl_sup) (2:=H0); intros.
destruct H2.
exists x2.
rewrite H3; trivial.
Qed.

  Lemma isOrd_sup : isOrd ord_sup.
apply isOrd_intro; intros.
 elim isOrd_sup_elim with (1:=H1); intros.
 apply isOrd_sup_intro with x.
 apply isOrd_plump with b; auto.

 elim isOrd_sup_elim with (1:=H); intros.
 apply isOrd_inv with (f x); trivial.
Qed.

End LimOrd.

Section LimOrdRel.

  Variable R : nat -> set -> Prop.
  Variable Rmorph : forall n x x', isOrd x -> x == x' -> R n x -> R n x'.
  Variable Rtot : forall n, exists x, R n x.
  Variable Rfun : forall n x x',
    isOrd x -> isOrd x' -> R n x -> R n x' -> x == x'.
  Variable Rord : forall n x, R n x -> isOrd x.

  Definition sup_rel :=
    union (repl N (fun x y => exists2 n, x == nat2set n & R n y)).

  Lemma repl_sup_rel : 
    repl_rel N (fun x y => exists2 n, x == nat2set n & R n y).
split; intros.
 destruct H2.
 exists x0.
  rewrite <- H0; trivial.
  apply Rmorph with y; eauto.

 destruct H0.
 destruct H1.
 apply Rfun with x0; trivial; eauto.
 replace x0 with x1; trivial.
 apply nat2set_inj.
 rewrite <- H1; trivial.
Qed.

  Lemma isOrd_sup_rel_intro2 : forall n y, R n y -> y \incl sup_rel.
unfold sup_rel.
red; intros.
apply union_intro with y; trivial.
apply repl_intro with (nat2set n).
 exact repl_sup_rel.

 apply nat2set_typ.

 exists n; trivial; reflexivity.
Qed.

  Lemma isOrd_sup_rel_intro : forall n,
    exists2 y, R n y & y \incl sup_rel.
intros.
elim (Rtot n); intros.
exists x; trivial.
apply isOrd_sup_rel_intro2 with n; trivial.
Qed.


  Lemma isOrd_sup_rel_elim :
    forall x, lt x sup_rel -> exists n, exists2 y, R n y & lt x y.
unfold sup_rel; intros.
elim union_elim with (1:=H); clear H; intros.
elim repl_elim with (1:=repl_sup_rel) (2:=H0); intros.
destruct H2.
exists x2.
exists x0; trivial.
Qed.

  Lemma isOrd_sup_rel : isOrd sup_rel.
apply isOrd_intro; intros.
 elim isOrd_sup_rel_elim with (1:=H1); intros.
 destruct H2.
 apply (isOrd_sup_rel_intro2 x x0); trivial.
 apply isOrd_plump with b; eauto.

 elim isOrd_sup_rel_elim with (1:=H); intros.
 destruct H0.
 apply isOrd_inv with x0; eauto.
Qed.

End LimOrdRel.

Fixpoint nat2ordset n :=
  match n with
  | 0 => zero
  | S k => osucc (nat2ordset k)
  end.

Lemma nat2ordset_typ : forall n, isOrd (nat2ordset n).
induction n; simpl; intros.
 apply isOrd_zero.
 apply isOrd_succ; trivial.
Qed.
Hint Resolve nat2ordset_typ.

(* Ordinal omega *)

Definition omega := ord_sup nat2ordset.

Lemma isOrd_omega : isOrd omega.
apply isOrd_sup; trivial.
Qed.
Hint Resolve isOrd_omega.

Lemma zero_omega : lt zero omega.
apply isOrd_sup_intro with 1; simpl.
apply lt_osucc; trivial.
Qed.
Hint Resolve zero_omega.

Lemma osucc_omega : forall n, lt n omega -> lt (osucc n) omega.
intros.
apply isOrd_sup_elim in H; destruct H.
apply isOrd_sup_intro with (S x); simpl.
apply lt_osucc_compat; auto.
Qed.
Hint Resolve osucc_omega.

Lemma omega_limit_ord : limitOrd omega.
split; auto.
Qed.
Hint Resolve omega_limit_ord.


Inductive ord : Set := OO | OS (o:ord) | OL (f:nat->ord).

Fixpoint ord2set (o:ord) : set :=
  match o with
  | OO => zero
  | OS k => osucc (ord2set k)
  | OL f => ord_sup (fun k => ord2set (f k)) 
  end.

Lemma ord2set_typ : forall o, isOrd (ord2set o).
induction o; simpl; intros.
 apply isOrd_zero.
 apply isOrd_succ; trivial.
 apply isOrd_sup; trivial.
Qed.
Hint Resolve ord2set_typ.

(* f^w(o) *)
Definition iter_w (f:set->set) o :=
  ord_sup(nat_rect(fun _=>set) o (fun _ => f)).

Lemma isOrd_iter_w : forall f o,
  (forall x, isOrd x -> isOrd (f x)) ->
  isOrd o ->
  isOrd (iter_w f o).
intros.
unfold iter_w.
apply isOrd_sup.
induction n; simpl; intros; auto.
Qed.

Definition plus_w := iter_w osucc.
Definition mult_w := iter_w plus_w.
Definition pow_w := iter_w mult_w.
Definition epsilon0 : set := iter_w pow_w omega.

Lemma isOrd_epsilon0: isOrd epsilon0.
unfold epsilon0, pow_w, mult_w, plus_w.
apply isOrd_iter_w; intros.
 apply isOrd_iter_w; intros; trivial. 
 apply isOrd_iter_w; intros; trivial. 
 apply isOrd_iter_w; intros; trivial. 
 apply isOrd_succ; trivial.

 apply isOrd_omega.
Qed.

Lemma zero_typ_e0 : zero \in epsilon0.
unfold epsilon0, iter_w.
apply isOrd_sup_intro with 0; simpl.
apply isOrd_sup_intro with 1; simpl.
apply lt_osucc; trivial.
Qed.

